import WebSocket from 'ws';

import { Storage } from '../storage.js';

let { com } = await import('../../config/@global_communication.js');


export class IPC {
    ws = null
    constructor() {
        const ws = new WebSocket(`ws://${com.host}:${com.port}/${com.path}`);

        ws.on('error', console.error);
        ws.on('open', function open() {
            let k = {
                type: "auth",
                bot: {
                    name: "Bot_1"
                }
            }
            ws.send(JSON.stringify(k));
        });

        ws.on('message', function message(data) {
            console.log('received: %s', data);
        });
        ws.on('open', this.heartbeat);
        ws.on('ping', this.heartbeat);
        this.ws = ws;
    }
    async receiveData() {

    }

    sendData(data) {
        this.ws.send(data)
    }
    heartbeat() {
        clearTimeout(this.pingTimeout);
        console.log("PING")

        // Use `WebSocket#terminate()`, which immediately destroys the connection,
        // instead of `WebSocket#close()`, which waits for the close timer.
        // Delay should be equal to the interval at which your server
        // sends out pings plus a conservative assumption of the latency.
        this.pingTimeout = setTimeout(() => {
            this.terminate();
        }, 30000 + 1000);
    }
}
