import { ModuleFrame } from "../module_frame.js";
import Vec3 from "vec3";



import { Storage } from "../../storage.js";
import Path from "mineflayer-pathfinder";


export class Farmer extends ModuleFrame {
    bts = null
    bth = null
    constructor() {
        super();
        this.bts = Storage.bot.registry.itemsByName["potato"]
        this.bth = Storage.bot.registry.blocksByName["potatoes"]
    }
    setItemToFarm() {

    }
    blockToSow() {
        return Storage.bot.findBlock({
            point: Storage.bot.entity.position,
            matching: Storage.bot.registry.blocksByName.farmland.id,
            maxDistance: 6,
            useExtraInfo: (block) => {
                const blockAbove = Storage.bot.blockAt(block.position.offset(0, 1, 0))
                return !blockAbove || blockAbove.type === 0
            }
        })
    }
    blockToHarvest() {
        return Storage.bot.findBlock({
            point: Storage.bot.entity.position,
            maxDistance: 5,
            matching: (block) => {
                return block && block.type === this.bth.id && block.metadata === 7
            }
        })
    }
    async loop() {
        try {
            while (1) {
                const toHarvest = this.blockToHarvest()
                if (toHarvest == null){
                    break;
                }
                await Storage.bot.pathfinder.goto(
                    new Path.goals.GoalNear(
                        toHarvest.position.x,
                        toHarvest.position.y,
                        toHarvest.position.z,
                        3
                    ),false
                )
                if (toHarvest) {
                    await Storage.bot.dig(toHarvest)
                } else {
                    break
                }
            }
            while (1) {
                const toSow = this.blockToSow()
                if (toSow == null){
                    break;
                }
                await Storage.bot.pathfinder.goto(
                    new Path.goals.GoalNear(
                        toSow.position.x,
                        toSow.position.y,
                        toSow.position.z,
                        3
                    ), false
                )
                if (toSow) {
                    await Storage.bot.equip(this.bts.id, 'hand')
                    await Storage.bot.placeBlock(toSow, new Vec3(0, 1, 0))
                } else {
                    break
                }
            }
        } catch (e) {
            console.log(e)
        }

        return false;
    }
}